 <template>
  <div class="login-page">
    <div class="content-block">
      <!--<form @submit.prevent="recoverPassword">-->
      <form>
        <div class="container" style="min-height: 100vh">
          <div class="margin-top-50"></div>
          <div class="content-block">
            <div class="white-block">
              <div class="padding">
                <h3>Восстановление пароля</h3>
              </div>
              <hr/>
              <div class="padding">
                <div class="row">
                 <div class="warning-block">
                   <b>Внимание</b><br>
                   Пароль должен содержать минимум 7 символов, включающих: цифры, БОЛЬШИЕ и маленькие латинские буквы.
                 </div>
                  <div class="columns six">
                    <label for="login">Новый пароль:</label>
                    <input
                      v-model="password"
                      type="password"
                      name="Пароль"
                      id="login"
                      v-validate="'required'"
                      :class="getValidateClass('Пароль')"
                    />
                    <validate-message
                      v-show="vErrors.has('Пароль')"
                    >{{ vErrors.first('Пароль') }}
                    </validate-message>
                  </div>
                  <div class="columns six">
                    <label for="password">Новый пароль еще раз:</label>
                    <input
                      v-model="passwordAgain"
                      type="password"
                      name="Пароль"
                      id="password"
                      v-validate="'required'"
                      :class="getValidateClass('Пароль')"
                    />
                    <validate-message
                      v-show="vErrors.has('Пароль')"
                    >{{ vErrors.first('Пароль') }}
                    </validate-message>
                  </div>
                </div>
              </div>
            </div>
            <transition name="fade">
              <div class="white-block" v-if="error">
                <div class="padding">
                  <div class="warning-block">
                    {{error}}
                  </div>
                </div>
              </div>
            </transition>
            <div class="center row">
              <button @click.prevent="recoverPassword">Поменять пароль</button>
              <button class="blue" @click="cancel">Отмена</button>
            </div>
          </div>
        </div>
      </form>
    </div>
  </div>
</template>

<script>
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import {recoverPassword} from '@/utils/api'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'

export default {
    name: 'PasswordRecovery',
    mixins: [GetValidateClass, ErrorHandleMixin],
    data () {
      return {
        password: '',
        passwordAgain: '',
        message: null,
        error: ''
      }
    },

  watch: {
      password () {
        this.error = '';
      },
      passwordAgain () {
        this.error = '';
      }
  },

    computed: {
      hash () {
        return this.$route.query && this.$route.query.hash
      },
      isPasswordsSame () {
        return this.password === this.passwordAgain;
      }
    },
    methods: {
      async recoverPassword () {
        if(!this.strong()) {
          this.$toastr.error('Пароль должен содержать минимум 7 символов, включающих: цифры, БОЛЬШИЕ и маленькие латинские буквы.', 'Слабый пароль');
          return false;
        }

        const validated = await this.$validator.validateAll();
        if (validated && this.isPasswordsSame) {
          this.AJAX_LOADING(true);
          this.$backend.api.user.password.change({
            password: this.password,
            emailHash: this.$route.query.hash
          }).then(() => {
            this.$toastr.success('Пароль изменен', 'Успешно');
            this.$router.push({name: 'login'});
          }).catch((e) => {
            const map = require('../../utils/error_mapper/user_password').default;
            if (e && Array.isArray(e.errors)) {
              const message = map[e.errors[0].code] || 'Произошла непредвиденная ошибка';
              this.$toastr.error(message, 'Ошибка');
              this.error = message;
            } else {
              this.$toastr.error('Произошла непредвиденная ошибка', 'Ошибка');
            }
          }).finally(() => {
            this.AJAX_LOADING(false);
          })

        } else {
          const message = validated ? 'Пароли не совпадают' : 'Пароль не задан в форме';
          this.$toastr.error(message, 'Ошибка');
          this.error = message;
        }

      },

      strong () {
        const regex = [
          /[A-Z]/.test(this.password),
          /[a-z]/.test(this.password),
          /[0-9]/.test(this.password),
          this.password.length >= 7
        ];

        return regex.every(pass => pass === true)
      },
      cancel () {
        this.$router.push({name: 'login', query: {}, fullPath: 'login'})
      }
    },
    mounted () {
      if (this.$route.query && this.$route.query['phone'] && this.$route.query['phone'] !== null) {
        this.$store.commit('REINSTATEMENT_BY_PHONE', {status: true, phone: this.$route.query['phone']});
        this.$router.push({name:'login'});
      }
    }
  }
</script>

<style scoped>

</style>
